#!/bin/sh

######################################################################
# RemoveDeletedHosts.sh
#
# Given a directory name, checks each host for a comment matching
# 'NACE DELETE' and removes the config files for those hosts. This is
# to prevent deleted hosts from being repeatedly autodetected.
#
# May need to override the default location for the comment.log file.

COMMENTLOG=/home/nagios/var/comment.log
DELETELOG=/home/nagios/var/NACEDeletions.log

# Update deletions from comments

cat $COMMENTLOG | grep "NACE DELETE" | cut -f3 -d\; | sort | uniq >> $DELETELOG
cat $DELETELOG | sort | uniq > ${DELETELOG}.new
mv ${DELETELOG}.new $DELETELOG

find $1 -type f -name '*.cfg' \
    | while read X 
  do

  TARGETHOST=`basename "$X" .cfg`

  grep "${TARGETHOST}" $DELETELOG >/dev/null && {
      [ -n "$DEBUG" ] && echo "Removing $X"
      rm -f ${X}*
      }

done
