#!/bin/sh -x

echo "This is an example script using NACE."
echo "to configure hosts and services on a small network."
echo ""
echo "This created the configurations in the examples directory."

#exit

{

######################################################################
# Grab hosts
nmap -sP 192.168.1.* -oG - \
	| awk '/Status: Up/ { print $2 }' \
	| ../bin/SNMPHostQueryData.pl -f 10 \
	| ../bin/NormalizeHostNames.pl -f 10 -s .adamsinfoserv.com \
	| ../bin/WriteHosts.pl \
	-O ./Auto/New \
	-d HG=HomeGroup \
	-a HG=HomeGroup \
	-d HT=HostTemplate

######################################################################
# Services

# All disks
../bin/ReturnHostsFromConfig.sh ./Auto/New \
	| ../bin/SNMPServiceOIDGrep.pl \
	-s 'CheckSNMPDisk!^@@@TARGET@@@$!80!90' \
	-d 'Disk @@@TARGET@@@' \
	-o 1.3.6.1.2.1.25.2.3.1.3 \
	-m '(^\/(?!dev)|^[A-Z]:.*Label.*Serial)' \
	-f 10 \
	| ../bin/WriteServices.pl \
	-d CG=HomeAdmins \
	-d ST=DiskServiceTemplate \
    -O ./Auto/New


../bin/ReturnHostsFromConfig.sh ./Auto/New \
	| ../bin/SNMPServiceQueryKey.pl \
	-s 'CheckSNMPProcess!@@@TARGET@@@!0,10!0,50' \
	-k PL \
	-d 'Process @@@TARGET@@@' \
	-f 10 \
	| ../bin/WriteServices.pl \
	-d CG=HomeAdmins \
	-d ST=DiskServiceTemplate \
	-O ./Auto/New


######################################################################
# Generate Hostgroups
../bin/GenerateHostGroups.pl \
	-I ./Auto/New \
	-O ./Auto/New \
	-d HG=WindowsServers \
	-d 'DS=Windows Servers' \
	-d CG=HomeAdmins

../bin/GenerateHostGroups.pl \
	-I ./Auto/New \
	-O ./Auto/New \
	-d HG=LinuxServers \
	-d 'DS=Linux Servers' \
	-d CG=HomeAdmins

../bin/GenerateHostGroups.pl \
	-I ./Auto/New \
	-O ./Auto/New \
	-d HG=HomeGroup \
	-d 'DS=Home Systems' \
	-d CG=HomeAdmins


# ######################################################################
# # Verify new configuration
# # nagios-New.cfg specifies ~/Auto/New instead of ~/Auto/Current
# /usr/local/apps/nagios-1.2/bin/nagios -v ~/etc/nagios-New.cfg \
# 	&& {

# 	# Install new files because Nagios validated new config
# 	MYDATE=`date +"%Y%m%d-%H%M%S"`
	
# 	# Archive our current config
# 	mv ~/Auto/Current ~/Auto/Archive/$MYDATE

# 	# Move in the new one
# 	mv ~/Auto/New ~/Auto/Current
# 	mkdir ~/Auto/New
	
# 	# Restart nagios
# 	kill -HUP `cat ~/var/nagios.lock`

# 	# Mail off a diff of what changed to the nagios admin
# 	diff -x *.log -NaruBr ~/Auto/Archive/$MYDATE/ ~/Auto/Current/ \
# 		| mail -s "$0: Update Successful $MYDATE" nagios

# } || {
	
# 	MYDATE=`date +"%Y%m%d-%H%M%S"`

# 	# Update failed, rollback changes.
	
# 	mv ~/Auto/New ~/Auto/Bad/$MYDATE
# 	mkdir ~/Auto/New

# 	# Mail a diff to the nagios admin to alert them to the problem.
# 	diff -x *.log -NaruBr ~/Auto/Current/ ~/Auto/Bad/$MYDATE/ \
# 		| mail -s "$0: Update Failed $MYDATE" nagios
	
# }

} 2>&1 3>&1 | tee ./Auto/New/QueryNetwork.log
